#ifndef __PLUGIN_HTTP_NORMALIZE__
#define __PLUGIN_HTTP_NORMALIZE__

#define NADS_WS_CASE_SENSITIVE	0x01UL /* Case sensitive paths */
#define NADS_WS_UTF8		0x02UL /* URIs are UTF-8 */
#define NADS_WS_MS_UTF16	0x04UL /* MS-UTF-16 (%uXXXX) */
#define NADS_WS_PERCENT_HACK	0x08UL /* Allow %%35 etc.. */
#define NADS_WS_DOUBLE_HEX	0x10UL /* Do hex decode twice */
#define NADS_WS_BACKSLASHES	0x20UL /* Flip \ to / in paths */

/* EXported API */
void __private http_normalize(struct packet *p, struct http_request *r)
	__nonull(1,2);
int __private nads_default_webserver(const char *name)
	__nonull(1);
int __private nads_webserver(u_int32_t ip, u_int16_t port, const char *emu)
	__nonull(3);
int __private http_normalize_init(void);
void __private http_normalize_fini(void);

/* Serialization API */
void __private *http_deserialize(struct packet *p, int i,
				const char *buf, size_t len);
int __private http_serialize(struct packet *p, int i, char *buf, size_t len);

/* Internal API */
int __private nads_ws(unsigned long x);
void __private select_webserver(u_int32_t ip, u_int16_t port);
extern struct tokenbucket __private http_tb;

#endif /* __PLUGIN_HTTP_NORMALIZE__ */
