/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __ARGS_HEADER_INCLUDED__
#define __ARGS_HEADER_INCLUDED__

#define ARGTYPE_CUSTOM		0U
#define ARGTYPE_STRING		1U
#define ARGTYPE_PSTRING		2U
#define ARGTYPE_UINT		3U
#define ARGTYPE_PUINT		4U
#define ARGTYPE_INT		5U
#define ARGTYPE_PINT		6U
#define ARGTYPE_BYTES		7U
#define ARGTYPE_PBYTES		8U
#define ARGTYPE_BOOL		9U
#define ARGTYPE_PBOOL		10U
#define ARGTYPE_DOUBLE		11U
#define ARGTYPE_PDOUBLE		12U
#define ARGTYPE_OFF		13U
#define ARGTYPE_POFF		14U
#define ARGTYPE_MAX		15U

#ifdef __GNUC__
struct arg;
#endif

typedef int(*arg_cbfn_t)(struct arg *, struct fvec *, void *);

union arg_val {
	arg_cbfn_t v_custom;

	struct fvec v_str;
	unsigned int v_bytes;
	unsigned int v_uint;
	unsigned int v_bool;
	double v_double;
	off_t v_off;
	int v_int;

	struct fvec *vp_str;
	unsigned int *vp_bytes;
	unsigned int *vp_uint;
	unsigned int *vp_bool;
	double *vp_double;
	off_t *vp_off;
	int *vp_int;
};

struct arg {
	const char *name;
	unsigned int type;
	union arg_val val;
	const char *def;
	const char *help;
	unsigned int count;
};

char *arg_get_string(struct fvec *v);
int arg_dispatch(struct arg *a, const char *key, const char *val, void *priv)
	__nonull(1,2,3);
int args_parse(struct arg *a, const char *str, void *) __nonull(1,2);
const char *args_typename(unsigned int type);

#endif /* __ARGS_HEADER_INCLUDED__ */
