/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __CAPDEV_HEADER_INCLUDED__
#define __CAPDEV_HEADER_INCLUDED__

#define CAPDEV_NBIO	(1<<0) /* capdev uses nbio */
#define CAPDEV_REALTIME	(1<<1) /* packet timestamp == system time */

struct capdev {
	struct packet *(*dequeue)(struct source *);
	off_t (*index)(struct packet *);
	struct packet *(*query)(struct source *, off_t);
	void (*rewind)(struct source *);
	int (*init)(struct source *, const char *args);
	void (*free)(struct source *);
	const char *name;
	const char *desc;
	unsigned long flags;
	struct arg *args;
	struct capdev *next;
};

void capdev_fd_add(struct source *, struct nbio *) __nonull(1,2);
void capdev_fd_inactive(struct source *, struct nbio *) __nonull(1,2);
void capdev_load(void);
struct __private capdev *capdev_find(const char *);
void capdev_init_packet(struct packet *, struct source *)
			__nonull(1,2);

static inline u_int32_t capdev_endian_flag(int swapped)
{
#if HOST_ORDER == FP_BIG_ENDIAN
	if ( !swapped )
#else
	if ( swapped )
#endif
		return FP_BIG_ENDIAN;
	return 0;
}

void serial_number(struct packet *) __nonull(1);

#endif /* __CAPDEV_HEADER_INCLUDED__ */
