/*
 * This file is part of dotscara
 * Copyright (c) 2004 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
 */
#ifndef __FDCTL_HEADER_INCLUDED__
#define __FDCTL_HEADER_INCLUDED__

#define FDCTL_NONBLOCK		0x01UL
#define FDCTL_COE		0x02UL
#define FDCTL_ANY		BITMASK_ANY

/* Internal APIs */
int __private __fd_read(int fd, void *buf, size_t *sz, int *eof)
	__nonull(2,3,4);
int __private __fd_write(int fd, const void *buf, size_t len)
	__nonull(2);
int __private __fd_close(int fd);

/* External APIs */
int __public fd_read(int fd, void *buf, size_t *sz, int *eof)
	__nonull(2,3,4);
int __public fd_write(int fd, const void *buf, size_t len)
	__nonull(2);
int __public fd_close(int fd);

int __public fdctl_block(int fd, int b);
int __public fdctl_coe(int fd, int coe);

#endif /* __FDCTL_HEADER_INCLUDED__ */
