/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __PREPROC_HEADER_INCLUDED__
#define __PREPROC_HEADER_INCLUDED__

typedef struct list_head *(*preproc_fn)(const char *, void *priv);

/* A preprocessor */
struct preproc {
	const char *name;
	int (*init)(const char *args, preproc_fn fn, void *priv);
	struct preproc *next;
};

void preproc_load(void);
struct preproc *preproc_find(const char *n) __private __nonull(1);

#endif /* __PREPROC_HEADER_INCLUDED__ */
