/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2003,2004 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __Q_TYPE_HEADER_INCLUDED__
#define __Q_TYPE_HEADER_INCLUDED__

/* Available token types */
#define QFT_INT		0
#define QFT_STRING	1
#define QFT_MAX		2

struct q_type {
	const char *name;
	int type; /* QFT_INT/QFT_STRING */
	int underlying_type;
	int (*validate)(const char *str, struct q_constraint *c);
};

struct q_type *q_type_get(const char *field, const char *val);
int q_type_compatible(struct q_type *t, int type);

#endif /* __Q_TYPE_HEADER_INCLUDED__ */
