/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001,2002,2003,2004 Gianni Tedesco
* This program is released under the terms of the GNU GPL version 2
*/

/* Fowler/Noll/Vo hash
* Its fast to compute, its obvious code, it performs well... */
static inline u_int32_t string_hash(const char *str) __nonull(1);
static inline u_int32_t string_hash(const char *str)
{
	u_int32_t h=2166136261UL;
	u_int8_t *data=(u_int8_t *)str;

	while(*data)
		h = (h * 16777619UL) ^ *data++;

	return h;
}

static inline u_int32_t fvec_hash(struct fvec *v) __nonull(1);
static inline u_int32_t fvec_hash(struct fvec *v)
{
	u_int32_t h=2166136261UL;
	u_int8_t *data=(u_int8_t *)v->ptr;
	u_int8_t *end = v->ptr + v->len;

	while(data < end)
		h = (h * 16777619UL) ^ *data++;

	return h;
}
